// Integrated buttons and C25k timer
// September 2022

//ISR interfering with tone command - to fix


/*
 The circuit:
 * SD card attached to SPI bus as follows: (Not used)
 ** MOSI - pin 11
 ** MISO - pin 12
 ** CLK - pin 13
 ** CS - pin 10 for deek robot data logging shield v1.0
 * 
 * RTC connections (I2C) - Clock not used in this project: (Not used )
 * gnd to gnd
 * + to +5V
 * SDA to A4
 * SCL to A5
 * 
 * LCD shield:
 * Backlight - pin 10 removed
 * B4 to D4
 * B5 to D5
 * B6 to D6
 * B7 to D7 
 * RS to D8
 * E to D9
 * 
 * LCD shield buttons:
 * Analog 0
 * 
 * Buzzer:
 * GND to GND
 * + to D3 
 */


//CHECK TO SEE IF LCD IS ONE OF THE FAULTY ONES
//MINE HAD PROBLEMS SO I DESOLDERED AND REMOVED THE FAULTY PIN 10
//REFERENCE - https://forum.arduino.cc/index.php?topic=96747.0 (Retrieved 7/June/2019)
//for the LCD shield
#include <LiquidCrystal.h>
// select the pins used on the lcd panel
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
// http://www.robotshop.com/content/PDF/dfrobot-lcd-keypad-shield-schematic.pdf 

// Struct used to allow jagged arrays
// See - https://forum.arduino.cc/t/multi-dimensional-arrays-with-different-number-of-elements/557252/2?msclkid=e1f2d9e2b44011ecb63f1d572262f5c5
// (Checked April 2022)


#define NUMELEMENTS(x) (sizeof(x) / sizeof(x[0]))
#define MULTIPLIER 1000 //multiplier

//#define my_test // Define week 1 as a set of short time durations for test purposes

// {wait, run, walk,... ,cooldown}

#ifdef my_test
int week1[]{3,6,9,6,9,6,9,6,9,6,9,6,9,6,9,6,9,3};//week 1
#else 
int week1[]{300,60,90,60,90,60,90,60,90,60,90,60,90,60,90,60,90,300};//week 1
#endif

int week2[]{300,120,90,120,90,120,90,120,90,120,90,300};//week 2
int week3[]{300,90,90,180,180,90,90,180,180,300};//week 3

int week4[]{300,180,90,300,150,300,300};//week 4

int week5a[]{300,300,180,300,180,300,300};//week 5 a
int week5b[]{300,480,300,480,300};//week 5 b
int week5c[]{300,1200,300};//week 5 c


int week6a[]{300,300,180,480,150,300,300};//week 6 a
int week6b[]{300,600,180,600,300};//week 6 b
int week6c[]{300,1500,300};//week 6 c

int week7[]{300,1500,300};//week 7
int week8[]{300,1680,300};//week 8 
int week9[]{300,1800,300};//week 9

struct WORKOUTS
{
  int *workouts;
  uint16_t numElements;
};

WORKOUTS workoutsMatrix[] =
{
  {week1, NUMELEMENTS(week1)},
  {week2, NUMELEMENTS(week2)},
  {week3, NUMELEMENTS(week3)},
  {week4, NUMELEMENTS(week4)},

  {week5a, NUMELEMENTS(week5a)},
  {week5b, NUMELEMENTS(week5b)},
  {week5c, NUMELEMENTS(week5c)},

  {week6a, NUMELEMENTS(week6a)},
  {week6b, NUMELEMENTS(week6b)},
  {week6c, NUMELEMENTS(week6c)},

  {week7, NUMELEMENTS(week7)},
  {week8, NUMELEMENTS(week8)},
  {week9, NUMELEMENTS(week9)},

};

// Text for display
String weeks_text []{"Week 1 ","Week 2 ","Week 3 ","Week 4 ","Week 5a","Week 5b","Week 5c","Week 6a","Week 6b","Week 6c","Week 7 ","Week 8 ","Week 9 "};

const int max_elements =13;

const int sounder_pin=3;// the pin we attach our sounder to
const int duty_cycle=128;//50% duty cycle for analogWrite()

#define LOW_FREQUENCY 0
#define HIGH_FREQUENCY 1

//required to debounce switch
#define MAX_CHECKS 10
volatile uint8_t Debounced_State=0;//accessed by isr and main loop code
uint8_t State[MAX_CHECKS]={0};
uint8_t Index=0;



void setup()
{

  // initialize digital pin as an output.
  pinMode(sounder_pin, OUTPUT);

        // initialize timer1 
  noInterrupts();           // disable all interrupts
  TCCR1A = 0;
  TCCR1B = 0;
  TCNT1  = 0;

  OCR1A = 625;              // compare match register  16MHX/256/100HZ 
  TCCR1B |= (1 << WGM12);   // CTC mode
  TCCR1B |= (1 << CS12);    // 256 prescaler 
  TIMSK1 |= (1 << OCIE1A);  // enable timer compare interrupt
  interrupts();

//initial lcd setup
  lcd.begin(16,2);    // initialize the lcd for 16 chars 2 lines    
  lcd.clear();

  //set up display for first time
  display_setup();

}

  
void loop()
{
  
  
  
//variables
bool select_pressed=false;
bool down_button=false;
bool up_button=false;

static bool button_up=false;
static bool chord_ready=false;
static int Stored_State=0;
static int Action_Me=0;

static int selection=1;

display_index(selection-1);


 
while(1){

    noInterrupts();           // disable all interrupts    
if (Debounced_State>Stored_State){Stored_State=Debounced_State;chord_ready=true;}//store chord and flag as ready
if (Debounced_State<Stored_State){if(chord_ready){button_up=true;Action_Me=Stored_State;}Stored_State=Debounced_State;} 
    interrupts();             // enable all interrupts

if(button_up && chord_ready)
{
chord_ready=false;
button_up=false;

if (Action_Me&1<<0){select_pressed=true;}//select button                      
if (Action_Me&1<<2){down_button=true;}//down button
if (Action_Me&1<<3){up_button=true;}//up button

}
 
if (select_pressed){
  
  select_pressed=false;
  
  int rowCount=selection-1;

  //beeeep
  TCCR2B = (TCCR2B & 0b11111000) | 0x04;
  analogWrite(sounder_pin, duty_cycle);
  delay(2000);
  analogWrite(sounder_pin,0);

  display_warmup();
  delay((unsigned long)workoutsMatrix[rowCount].workouts[0]*MULTIPLIER);

  
  for(uint16_t colCnt = 1; colCnt < workoutsMatrix[rowCount].numElements-2; colCnt++){
  

  if(colCnt&1){

    display_run();
    
  //beep
  TCCR2B = (TCCR2B & 0b11111000) | 0x02;
  analogWrite(sounder_pin, duty_cycle);
  delay(100);
  analogWrite(sounder_pin,0);

  delay((unsigned long)workoutsMatrix[rowCount].workouts[colCnt]*MULTIPLIER);
 
  }
  else{

    display_walk();
    
    //beep beep
    TCCR2B = (TCCR2B & 0b11111000) | 0x04;
    analogWrite(sounder_pin, duty_cycle);
    delay(100);
    analogWrite(sounder_pin,0);
    delay(100);
    analogWrite(sounder_pin, duty_cycle);
    delay(100);
    analogWrite(sounder_pin,0);
    
    delay((unsigned long)workoutsMatrix[rowCount].workouts[colCnt]*MULTIPLIER);
    
  }
}
    display_cooldown();
    
    //beep beep
    TCCR2B = (TCCR2B & 0b11111000) | 0x04;
    analogWrite(sounder_pin, duty_cycle);
    delay(100);
    analogWrite(sounder_pin,0);
    delay(100);
    analogWrite(sounder_pin, duty_cycle);
    delay(100);
    analogWrite(sounder_pin,0);

    delay((unsigned long)workoutsMatrix[rowCount].workouts[workoutsMatrix[rowCount].numElements-1]*MULTIPLIER);

    //beeeep
    TCCR2B = (TCCR2B & 0b11111000) | 0x04;
    analogWrite(sounder_pin, duty_cycle);
    delay(2000);
    analogWrite(sounder_pin,0);

    display_stop();
  
  } 
                   

if (down_button){
  
  down_button=false;
  selection--;
  if (selection<1){selection=max_elements;}
  display_index(selection-1);

                  }

if (up_button){
  
  up_button=false;
  selection++;
  if (selection>max_elements){selection=1;}
  display_index(selection-1); 
}                
                         
}// End of while(1)
}// End of loop



ISR(TIMER1_COMPA_vect)          // timer compare interrupt service routine
{

//read buttons
  uint8_t temp=0x00;
/*
 * //rough values from read of analog buttons
636 //select
408 //left
254 //down
101 //up
0   //right
*/  
 if (analogRead(0) > 600  && analogRead(0) < 650){temp|=1<<0;} //select  
 if (analogRead(0) > 380 && analogRead(0) < 450){temp|=1<<1;} //left
 if (analogRead(0) > 200 && analogRead(0) < 300){temp|=1<<2;} //down
 if (analogRead(0) > 50 && analogRead(0) < 150){temp|=1<<3;} //up
 if (analogRead(0) >= 0 && analogRead(0) < 45){temp|=1<<4;} //right
 
//debounce
  uint8_t i,j;
  State[Index]= temp;
  ++Index;
  j=0xFF;
  for (i=0;i<MAX_CHECKS;i++){j=j&State[i];}
  Debounced_State=j;
  if(Index>=MAX_CHECKS){Index=0;} 
}

//for the display

//the initial setup
void display_setup(){  
  lcd.clear();
  lcd.setCursor(6,0);
  lcd.print("C25K");
  

  }

void display_index(int index){

  lcd.setCursor(5,1);
  lcd.print(weeks_text[index]);
  
  }

  
void display_warmup(){

  lcd.setCursor(5,1);
  lcd.print("Warm-up");
 
  }

  
void display_run(){
  
  lcd.setCursor(5,1);
  lcd.print(" Run   "); 
  
  }

  
void display_walk(){
  
  lcd.setCursor(5,1);
  lcd.print(" Walk  "); 
  
  }

void display_cooldown(){
  
  
  lcd.setCursor(4,1);
  lcd.print("Cooldown");
  
  }
  
void display_stop(){ 
  
  lcd.setCursor(4,1);
  lcd.print("  Stop  ");  
  
  }
// End of program
